/* contacts-avatar.c generated by valac 0.50.8, the Vala compiler
 * generated from contacts-avatar.vala, do not modify */

/*
 * Copyright (C) 2011 Alexander Larsson <alexl@redhat.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include "contacts.h"
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <folks/folks.h>
#include <string.h>

#define CONTACTS_TYPE_AVATAR (contacts_avatar_get_type ())
#define CONTACTS_AVATAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTACTS_TYPE_AVATAR, ContactsAvatar))
#define CONTACTS_AVATAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTACTS_TYPE_AVATAR, ContactsAvatarClass))
#define CONTACTS_IS_AVATAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTACTS_TYPE_AVATAR))
#define CONTACTS_IS_AVATAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTACTS_TYPE_AVATAR))
#define CONTACTS_AVATAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTACTS_TYPE_AVATAR, ContactsAvatarClass))

typedef struct _ContactsAvatar ContactsAvatar;
typedef struct _ContactsAvatarClass ContactsAvatarClass;
typedef struct _ContactsAvatarPrivate ContactsAvatarPrivate;
enum  {
	CONTACTS_AVATAR_0_PROPERTY,
	CONTACTS_AVATAR_NUM_PROPERTIES
};
static GParamSpec* contacts_avatar_properties[CONTACTS_AVATAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GdkRGBA_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkRGBA_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ContactsAvatarLoadAvatarData ContactsAvatarLoadAvatarData;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ContactsAvatar {
	GtkDrawingArea parent_instance;
	ContactsAvatarPrivate * priv;
};

struct _ContactsAvatarClass {
	GtkDrawingAreaClass parent_class;
};

struct _ContactsAvatarPrivate {
	gint size;
	GdkPixbuf* pixbuf;
	ContactsContact* contact;
	gboolean avatar_loaded;
	GdkRGBA* bg_color;
};

struct _ContactsAvatarLoadAvatarData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ContactsAvatar* self;
	ContactsContact* _tmp0_;
	GInputStream* stream;
	ContactsContact* _tmp1_;
	FolksIndividual* _tmp2_;
	GLoadableIcon* _tmp3_;
	GLoadableIcon* _tmp4_;
	GInputStream* _tmp5_;
	GdkPixbuf* _tmp6_;
	GInputStream* _tmp7_;
	GdkPixbuf* _tmp8_;
	GdkPixbuf* _tmp9_;
	GError* e;
	ContactsContact* _tmp10_;
	FolksIndividual* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	GError* _tmp14_;
	const gchar* _tmp15_;
	GError* _inner_error0_;
};

static gint ContactsAvatar_private_offset;
static gpointer contacts_avatar_parent_class = NULL;

GType contacts_avatar_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContactsAvatar, g_object_unref)
static void _vala_GdkRGBA_free (GdkRGBA* self);
ContactsAvatar* contacts_avatar_new (gint size,
                                     ContactsContact* contact);
ContactsAvatar* contacts_avatar_construct (GType object_type,
                                           gint size,
                                           ContactsContact* contact);
static void ___lambda5_ (ContactsAvatar* self,
                  GObject* s,
                  GParamSpec* p);
static void contacts_avatar_load_avatar (ContactsAvatar* self,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_);
static void contacts_avatar_load_avatar_finish (ContactsAvatar* self,
                                         GAsyncResult* _res_);
static void ____lambda5__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
void contacts_avatar_set_pixbuf (ContactsAvatar* self,
                                 GdkPixbuf* a_pixbuf);
static void contacts_avatar_load_avatar_data_free (gpointer _data);
static gboolean contacts_avatar_load_avatar_co (ContactsAvatarLoadAvatarData* _data_);
static void contacts_avatar_load_avatar_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_);
static gboolean contacts_avatar_real_draw (GtkWidget* base,
                                    cairo_t* cr);
static void contacts_avatar_draw_contact_avatar (ContactsAvatar* self,
                                          cairo_t* cr);
static void contacts_avatar_draw_fallback (ContactsAvatar* self,
                                    cairo_t* cr);
static void contacts_avatar_create_circle (ContactsAvatar* self,
                                    cairo_t* cr);
static void contacts_avatar_calculate_color (ContactsAvatar* self);
static GdkRGBA* _vala_GdkRGBA_copy (GdkRGBA* self);
static void contacts_avatar_finalize (GObject * obj);
static GType contacts_avatar_get_type_once (void);

static const GdkRGBA CONTACTS_AVATAR_fg_color = {(gdouble) 0, (gdouble) 0, (gdouble) 0, 0.25};

static inline gpointer
contacts_avatar_get_instance_private (ContactsAvatar* self)
{
	return G_STRUCT_MEMBER_P (self, ContactsAvatar_private_offset);
}

static void
_vala_GdkRGBA_free (GdkRGBA* self)
{
	g_boxed_free (gdk_rgba_get_type (), self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
___lambda5_ (ContactsAvatar* self,
             GObject* s,
             GParamSpec* p)
{
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
	contacts_avatar_load_avatar (self, NULL, NULL);
}

static void
____lambda5__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	___lambda5_ ((ContactsAvatar*) self, _sender, pspec);
}

ContactsAvatar*
contacts_avatar_construct (GType object_type,
                           gint size,
                           ContactsContact* contact)
{
	ContactsAvatar * self = NULL;
	ContactsContact* _tmp0_;
	gboolean _tmp2_ = FALSE;
	self = (ContactsAvatar*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (contact);
	_g_object_unref0 (self->priv->contact);
	self->priv->contact = _tmp0_;
	if (contact != NULL) {
		FolksIndividual* _tmp1_;
		_tmp1_ = contact->individual;
		g_signal_connect_object ((GObject*) _tmp1_, "notify::avatar", (GCallback) ____lambda5__g_object_notify, self, 0);
	}
	self->priv->size = size;
	gtk_widget_set_size_request ((GtkWidget*) self, size, size);
	if (contact == NULL) {
		_tmp2_ = TRUE;
	} else {
		FolksIndividual* _tmp3_;
		GLoadableIcon* _tmp4_;
		GLoadableIcon* _tmp5_;
		_tmp3_ = contact->individual;
		_tmp4_ = folks_avatar_details_get_avatar ((FolksAvatarDetails*) _tmp3_);
		_tmp5_ = _tmp4_;
		_tmp2_ = _tmp5_ == NULL;
	}
	self->priv->avatar_loaded = _tmp2_;
	gtk_widget_show ((GtkWidget*) self);
	return self;
}

ContactsAvatar*
contacts_avatar_new (gint size,
                     ContactsContact* contact)
{
	return contacts_avatar_construct (CONTACTS_TYPE_AVATAR, size, contact);
}

/**
   * Manually set the avatar to the given pixbuf, even if the contact has an avatar.
   */
void
contacts_avatar_set_pixbuf (ContactsAvatar* self,
                            GdkPixbuf* a_pixbuf)
{
	GdkPixbuf* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (a_pixbuf);
	_g_object_unref0 (self->priv->pixbuf);
	self->priv->pixbuf = _tmp0_;
	gtk_widget_queue_draw ((GtkWidget*) self);
}

static void
contacts_avatar_load_avatar_data_free (gpointer _data)
{
	ContactsAvatarLoadAvatarData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (ContactsAvatarLoadAvatarData, _data_);
}

static void
contacts_avatar_load_avatar (ContactsAvatar* self,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_)
{
	ContactsAvatarLoadAvatarData* _data_;
	ContactsAvatar* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (ContactsAvatarLoadAvatarData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, contacts_avatar_load_avatar_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	contacts_avatar_load_avatar_co (_data_);
}

static void
contacts_avatar_load_avatar_finish (ContactsAvatar* self,
                                    GAsyncResult* _res_)
{
	ContactsAvatarLoadAvatarData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
contacts_avatar_load_avatar_ready (GObject* source_object,
                                   GAsyncResult* _res_,
                                   gpointer _user_data_)
{
	ContactsAvatarLoadAvatarData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	contacts_avatar_load_avatar_co (_data_);
}

static gboolean
contacts_avatar_load_avatar_co (ContactsAvatarLoadAvatarData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->priv->contact;
	_vala_assert (_data_->_tmp0_ != NULL, "this.contact != null");
	_data_->self->priv->avatar_loaded = TRUE;
	{
		_data_->_tmp1_ = _data_->self->priv->contact;
		_data_->_tmp2_ = _data_->_tmp1_->individual;
		_data_->_tmp3_ = folks_avatar_details_get_avatar ((FolksAvatarDetails*) _data_->_tmp2_);
		_data_->_tmp4_ = _data_->_tmp3_;
		_data_->_state_ = 1;
		g_loadable_icon_load_async (_data_->_tmp4_, _data_->self->priv->size, NULL, contacts_avatar_load_avatar_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp5_ = g_loadable_icon_load_finish (_data_->_tmp4_, _data_->_res_, NULL, &_data_->_inner_error0_);
		_data_->stream = _data_->_tmp5_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp7_ = _data_->stream;
		_data_->_state_ = 2;
		gdk_pixbuf_new_from_stream_at_scale_async (_data_->_tmp7_, _data_->self->priv->size, _data_->self->priv->size, TRUE, NULL, contacts_avatar_load_avatar_ready, _data_);
		return FALSE;
		_state_2:
		_data_->_tmp8_ = (GdkPixbuf*) gdk_pixbuf_new_from_stream_finish (_data_->_res_, &_data_->_inner_error0_);
		_data_->_tmp6_ = _data_->_tmp8_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_object_unref0 (_data_->stream);
			goto __catch0_g_error;
		}
		_data_->_tmp9_ = _data_->_tmp6_;
		_data_->_tmp6_ = NULL;
		_g_object_unref0 (_data_->self->priv->pixbuf);
		_data_->self->priv->pixbuf = _data_->_tmp9_;
		gtk_widget_queue_draw ((GtkWidget*) _data_->self);
		_g_object_unref0 (_data_->_tmp6_);
		_g_object_unref0 (_data_->stream);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp10_ = _data_->self->priv->contact;
		_data_->_tmp11_ = _data_->_tmp10_->individual;
		_data_->_tmp12_ = folks_individual_get_display_name (_data_->_tmp11_);
		_data_->_tmp13_ = _data_->_tmp12_;
		_data_->_tmp14_ = _data_->e;
		_data_->_tmp15_ = _data_->_tmp14_->message;
		g_debug ("contacts-avatar.vala:74: Couldn't load avatar of contact %s. Reason: %" \
"s", _data_->_tmp13_, _data_->_tmp15_);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static gboolean
contacts_avatar_real_draw (GtkWidget* base,
                           cairo_t* cr)
{
	ContactsAvatar * self;
	GdkPixbuf* _tmp0_;
	gboolean result = FALSE;
	self = (ContactsAvatar*) base;
	g_return_val_if_fail (cr != NULL, FALSE);
	if (!self->priv->avatar_loaded) {
		contacts_avatar_load_avatar (self, NULL, NULL);
	}
	_tmp0_ = self->priv->pixbuf;
	if (_tmp0_ != NULL) {
		contacts_avatar_draw_contact_avatar (self, cr);
	} else {
		contacts_avatar_draw_fallback (self, cr);
	}
	result = TRUE;
	return result;
}

static void
contacts_avatar_draw_contact_avatar (ContactsAvatar* self,
                                     cairo_t* cr)
{
	GdkPixbuf* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	_tmp0_ = self->priv->pixbuf;
	gdk_cairo_set_source_pixbuf (cr, _tmp0_, (gdouble) 0, (gdouble) 0);
	contacts_avatar_create_circle (self, cr);
	cairo_clip_preserve (cr);
	cairo_paint (cr);
}

static void
contacts_avatar_draw_fallback (ContactsAvatar* self,
                               cairo_t* cr)
{
	GdkRGBA* _tmp0_;
	GdkRGBA* _tmp1_;
	GdkRGBA* _tmp2_;
	GdkRGBA* _tmp3_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	_tmp0_ = self->priv->bg_color;
	if (_tmp0_ == NULL) {
		contacts_avatar_calculate_color (self);
	}
	_tmp1_ = self->priv->bg_color;
	_tmp2_ = self->priv->bg_color;
	_tmp3_ = self->priv->bg_color;
	cairo_set_source_rgb (cr, (*_tmp1_).red, (*_tmp2_).green, (*_tmp3_).blue);
	cairo_arc (cr, (gdouble) (self->priv->size / 2), (gdouble) (self->priv->size / 2), (gdouble) (self->priv->size / 2), (gdouble) 0, 2 * G_PI);
	contacts_avatar_create_circle (self, cr);
	cairo_fill_preserve (cr);
	{
		GtkIconTheme* theme = NULL;
		GtkIconTheme* _tmp4_;
		GtkIconTheme* _tmp5_;
		GtkIconInfo* fallback_avatar = NULL;
		GtkIconInfo* _tmp6_;
		GdkPixbuf* icon_pixbuf = NULL;
		GdkPixbuf* _tmp7_;
		_tmp4_ = gtk_icon_theme_get_default ();
		_tmp5_ = _g_object_ref0 (_tmp4_);
		theme = _tmp5_;
		_tmp6_ = gtk_icon_theme_lookup_icon (theme, "avatar-default", (self->priv->size * 4) / 5, GTK_ICON_LOOKUP_FORCE_SYMBOLIC);
		fallback_avatar = _tmp6_;
		_tmp7_ = gtk_icon_info_load_symbolic (fallback_avatar, &CONTACTS_AVATAR_fg_color, NULL, NULL, NULL, NULL, &_inner_error0_);
		icon_pixbuf = _tmp7_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (fallback_avatar);
			_g_object_unref0 (theme);
			goto __catch0_g_error;
		}
		contacts_avatar_create_circle (self, cr);
		cairo_clip_preserve (cr);
		gdk_cairo_set_source_pixbuf (cr, icon_pixbuf, (gdouble) (1 + (self->priv->size / 10)), (gdouble) (1 + (self->priv->size / 5)));
		cairo_paint (cr);
		_g_object_unref0 (icon_pixbuf);
		_g_object_unref0 (fallback_avatar);
		_g_object_unref0 (theme);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = e;
		_tmp9_ = _tmp8_->message;
		g_warning ("contacts-avatar.vala:123: Couldn't get default avatar icon: %s", _tmp9_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static GdkRGBA*
_vala_GdkRGBA_copy (GdkRGBA* self)
{
	return g_boxed_copy (gdk_rgba_get_type (), self);
}

static gpointer
__vala_GdkRGBA_copy0 (gpointer self)
{
	return self ? _vala_GdkRGBA_copy (self) : NULL;
}

static void
contacts_avatar_calculate_color (ContactsAvatar* self)
{
	guint _tmp0_ = 0U;
	ContactsContact* _tmp1_;
	guint hash = 0U;
	gdouble r = 0.0;
	gdouble g = 0.0;
	gdouble b = 0.0;
	GdkRGBA _tmp7_ = {0};
	GdkRGBA* _tmp8_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->contact;
	if (_tmp1_ != NULL) {
		GHashFunc _tmp2_;
		ContactsContact* _tmp3_;
		FolksIndividual* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		_tmp2_ = g_str_hash;
		_tmp3_ = self->priv->contact;
		_tmp4_ = _tmp3_->individual;
		_tmp5_ = folks_individual_get_id (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = _tmp2_ (_tmp6_);
	} else {
		_tmp0_ = (guint) GDK_CURRENT_TIME;
	}
	hash = _tmp0_;
	r = ((hash & 0xFF0000) >> 16) / 255.0;
	g = ((hash & 0x00FF00) >> 8) / 255.0;
	b = (hash & 0x0000FF) / 255.0;
	memset (&_tmp7_, 0, sizeof (GdkRGBA));
	_tmp7_.red = (r + 2) / 3.0;
	_tmp7_.green = (g + 2) / 3.0;
	_tmp7_.blue = (b + 2) / 3.0;
	_tmp7_.alpha = (gdouble) 0;
	_tmp8_ = __vala_GdkRGBA_copy0 (&_tmp7_);
	__vala_GdkRGBA_free0 (self->priv->bg_color);
	self->priv->bg_color = _tmp8_;
}

static void
contacts_avatar_create_circle (ContactsAvatar* self,
                               cairo_t* cr)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (cr != NULL);
	cairo_arc (cr, (gdouble) (self->priv->size / 2), (gdouble) (self->priv->size / 2), (gdouble) (self->priv->size / 2), (gdouble) 0, 2 * G_PI);
}

static void
contacts_avatar_class_init (ContactsAvatarClass * klass,
                            gpointer klass_data)
{
	contacts_avatar_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ContactsAvatar_private_offset);
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) contacts_avatar_real_draw;
	G_OBJECT_CLASS (klass)->finalize = contacts_avatar_finalize;
}

static void
contacts_avatar_instance_init (ContactsAvatar * self,
                               gpointer klass)
{
	self->priv = contacts_avatar_get_instance_private (self);
	self->priv->pixbuf = NULL;
	self->priv->contact = NULL;
	self->priv->avatar_loaded = FALSE;
	self->priv->bg_color = NULL;
}

static void
contacts_avatar_finalize (GObject * obj)
{
	ContactsAvatar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CONTACTS_TYPE_AVATAR, ContactsAvatar);
	_g_object_unref0 (self->priv->pixbuf);
	_g_object_unref0 (self->priv->contact);
	__vala_GdkRGBA_free0 (self->priv->bg_color);
	G_OBJECT_CLASS (contacts_avatar_parent_class)->finalize (obj);
}

/**
 * The Avatar of a Contact is responsible for showing an {@link Folks.Individual}'s
 * avatar, or a fallback if it's not available.
 */
static GType
contacts_avatar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ContactsAvatarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) contacts_avatar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ContactsAvatar), 0, (GInstanceInitFunc) contacts_avatar_instance_init, NULL };
	GType contacts_avatar_type_id;
	contacts_avatar_type_id = g_type_register_static (gtk_drawing_area_get_type (), "ContactsAvatar", &g_define_type_info, 0);
	ContactsAvatar_private_offset = g_type_add_instance_private (contacts_avatar_type_id, sizeof (ContactsAvatarPrivate));
	return contacts_avatar_type_id;
}

GType
contacts_avatar_get_type (void)
{
	static volatile gsize contacts_avatar_type_id__volatile = 0;
	if (g_once_init_enter (&contacts_avatar_type_id__volatile)) {
		GType contacts_avatar_type_id;
		contacts_avatar_type_id = contacts_avatar_get_type_once ();
		g_once_init_leave (&contacts_avatar_type_id__volatile, contacts_avatar_type_id);
	}
	return contacts_avatar_type_id__volatile;
}

